LLVM::Attribute - Crystal 1.20.2

# enum LLVM::Attribute

##
Defined in:

llvm/enums.cr

##
Enum Members

Alignment = `1_u64`
AllocSize = `2_u64`
AlwaysInline = `4_u64`
ArgMemOnly = `8_u64`
Builtin = `16_u64`
ByVal = `32_u64`
Cold = `64_u64`
Convergent = `128_u64`
Dereferenceable = `256_u64`
DereferenceableOrNull = `512_u64`
InAlloca = `1024_u64`
InReg = `2048_u64`
InaccessibleMemOnly = `4096_u64`
InaccessibleMemOrArgMemOnly = `8192_u64`
InlineHint = `16384_u64`
JumpTable = `32768_u64`
MinSize = `65536_u64`
Naked = `131072_u64`
Nest = `262144_u64`
NoAlias = `524288_u64`
NoBuiltin = `1048576_u64`
NoCapture = `2097152_u64`
NoDuplicate = `4194304_u64`
NoFree = `8388608_u64`
NoImplicitFloat = `16777216_u64`
NoInline = `33554432_u64`
NoRecurse = `67108864_u64`
NoRedZone = `134217728_u64`
NoReturn = `268435456_u64`
NoSync = `536870912_u64`
NoUnwind = `1073741824_u64`
NonLazyBind = `2147483648_u64`
NonNull = `4294967296_u64`
OptimizeForSize = `8589934592_u64`
OptimizeNone = `17179869184_u64`
ReadNone = `34359738368_u64`
ReadOnly = `68719476736_u64`
Returned = `137438953472_u64`
ImmArg = `274877906944_u64`
ReturnsTwice = `549755813888_u64`
SExt = `1099511627776_u64`
SafeStack = `2199023255552_u64`
SanitizeAddress = `4398046511104_u64`
SanitizeMemory = `8796093022208_u64`
SanitizeThread = `17592186044416_u64`
StackAlignment = `35184372088832_u64`
StackProtect = `70368744177664_u64`
StackProtectReq = `140737488355328_u64`
StackProtectStrong = `281474976710656_u64`
StructRet = `562949953421312_u64`
SwiftError = `1125899906842624_u64`
SwiftSelf = `2251799813685248_u64`
UWTable = `4503599627370496_u64`
WillReturn = `9007199254740992_u64`
WriteOnly = `18014398509481984_u64`
ZExt = `36028797018963968_u64`
Captures = `72057594037927936_u64`
None = `0_u64`
All = `144115188075855871_u64`

##
Class Method Summary

- .from_kind(kind)
- .kind_for(member)
- .requires_type?(kind)

##
Instance Method Summary

- #alignment?

  Returns `true` if this enum value contains `Alignment`

- #alloc_size?

  Returns `true` if this enum value contains `AllocSize`

- #always_inline?

  Returns `true` if this enum value contains `AlwaysInline`

- #arg_mem_only?

  Returns `true` if this enum value contains `ArgMemOnly`

- #builtin?

  Returns `true` if this enum value contains `Builtin`

- #by_val?

  Returns `true` if this enum value contains `ByVal`

- #captures?

  Returns `true` if this enum value contains `Captures`

- #cold?

  Returns `true` if this enum value contains `Cold`

- #convergent?

  Returns `true` if this enum value contains `Convergent`

- #dereferenceable?

  Returns `true` if this enum value contains `Dereferenceable`

- #dereferenceable_or_null?

  Returns `true` if this enum value contains `DereferenceableOrNull`

- #each_kind(& : UInt32 -> )
- #imm_arg?

  Returns `true` if this enum value contains `ImmArg`

- #in_alloca?

  Returns `true` if this enum value contains `InAlloca`

- #in_reg?

  Returns `true` if this enum value contains `InReg`

- #inaccessible_mem_only?

  Returns `true` if this enum value contains `InaccessibleMemOnly`

- #inaccessible_mem_or_arg_mem_only?

  Returns `true` if this enum value contains `InaccessibleMemOrArgMemOnly`

- #inline_hint?

  Returns `true` if this enum value contains `InlineHint`

- #jump_table?

  Returns `true` if this enum value contains `JumpTable`

- #min_size?

  Returns `true` if this enum value contains `MinSize`

- #naked?

  Returns `true` if this enum value contains `Naked`

- #nest?

  Returns `true` if this enum value contains `Nest`

- #no_alias?

  Returns `true` if this enum value contains `NoAlias`

- #no_builtin?

  Returns `true` if this enum value contains `NoBuiltin`

- #no_capture?

  Returns `true` if this enum value contains `NoCapture`

- #no_duplicate?

  Returns `true` if this enum value contains `NoDuplicate`

- #no_free?

  Returns `true` if this enum value contains `NoFree`

- #no_implicit_float?

  Returns `true` if this enum value contains `NoImplicitFloat`

- #no_inline?

  Returns `true` if this enum value contains `NoInline`

- #no_recurse?

  Returns `true` if this enum value contains `NoRecurse`

- #no_red_zone?

  Returns `true` if this enum value contains `NoRedZone`

- #no_return?

  Returns `true` if this enum value contains `NoReturn`

- #no_sync?

  Returns `true` if this enum value contains `NoSync`

- #no_unwind?

  Returns `true` if this enum value contains `NoUnwind`

- #non_lazy_bind?

  Returns `true` if this enum value contains `NonLazyBind`

- #non_null?

  Returns `true` if this enum value contains `NonNull`

- #none?
- #optimize_for_size?

  Returns `true` if this enum value contains `OptimizeForSize`

- #optimize_none?

  Returns `true` if this enum value contains `OptimizeNone`

- #read_none?

  Returns `true` if this enum value contains `ReadNone`

- #read_only?

  Returns `true` if this enum value contains `ReadOnly`

- #returned?

  Returns `true` if this enum value contains `Returned`

- #returns_twice?

  Returns `true` if this enum value contains `ReturnsTwice`

- #s_ext?

  Returns `true` if this enum value contains `SExt`

- #safe_stack?

  Returns `true` if this enum value contains `SafeStack`

- #sanitize_address?

  Returns `true` if this enum value contains `SanitizeAddress`

- #sanitize_memory?

  Returns `true` if this enum value contains `SanitizeMemory`

- #sanitize_thread?

  Returns `true` if this enum value contains `SanitizeThread`

- #stack_alignment?

  Returns `true` if this enum value contains `StackAlignment`

- #stack_protect?

  Returns `true` if this enum value contains `StackProtect`

- #stack_protect_req?

  Returns `true` if this enum value contains `StackProtectReq`

- #stack_protect_strong?

  Returns `true` if this enum value contains `StackProtectStrong`

- #struct_ret?

  Returns `true` if this enum value contains `StructRet`

- #swift_error?

  Returns `true` if this enum value contains `SwiftError`

- #swift_self?

  Returns `true` if this enum value contains `SwiftSelf`

- #uw_table?

  Returns `true` if this enum value contains `UWTable`

- #will_return?

  Returns `true` if this enum value contains `WillReturn`

- #write_only?

  Returns `true` if this enum value contains `WriteOnly`

- #z_ext?

  Returns `true` if this enum value contains `ZExt`

### Instance methods inherited from struct `Enum`

&(other : self) : self &, +(other : Int) : self +, -(other : Int) : self -, <=>(other : self) <=>, ==(other : self)
==(other) ==, ^(other : self) : self ^, |(other : self) : self |, ~ : self ~, clone clone, each(& : self -> ) each, hash(hasher) hash, includes?(other : self) : Bool includes?, inspect(io : IO) : Nil inspect, to_f32 : Float32 to_f32, to_f32! : Float32 to_f32!, to_f64 : Float64 to_f64, to_f64! : Float64 to_f64!, to_i : Int32 to_i, to_i128 : Int128 to_i128, to_i128! : Int128 to_i128!, to_i16 : Int16 to_i16, to_i16! : Int16 to_i16!, to_i32 : Int32 to_i32, to_i32! : Int32 to_i32!, to_i64 : Int64 to_i64, to_i64! : Int64 to_i64!, to_i8 : Int8 to_i8, to_i8! : Int8 to_i8!, to_json(json : JSON::Builder) : Nil to_json, to_s(io : IO) : Nil
to_s : String to_s, to_u128 : UInt128 to_u128, to_u128! : UInt128 to_u128!, to_u16 : UInt16 to_u16, to_u16! : UInt16 to_u16!, to_u32 : UInt32 to_u32, to_u32! : UInt32 to_u32!, to_u64 : UInt64 to_u64, to_u64! : UInt64 to_u64!, to_u8 : UInt8 to_u8, to_u8! : UInt8 to_u8!, to_yaml(yaml : YAML::Nodes::Builder) to_yaml, value : Int value

### Constructor methods inherited from struct `Enum`

from_value(value : Int) : self from_value, new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
new(value : self)
new(pull : JSON::PullParser) : self new, parse(string : String) : self parse

### Class methods inherited from struct `Enum`

each(& : self -> ) each, from_value?(value : Int) : self | Nil from_value?, names : Array(String) names, parse?(string : String) : self | Nil parse?, valid?(value : self) : Bool valid?, values : Array(self) values

### Macros inherited from struct `Enum`

[](*values) [], flags(*values) flags

### Instance methods inherited from module `Comparable(Enum)`

<(other : T) : Bool <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) : Bool >, >=(other : T) >=, clamp(min, max)
clamp(range : Range) clamp

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Class Method Detail

def self.from_kind(kind) #
def self.kind_for(member) #
def self.requires_type?(kind) #

##
Instance Method Detail

def alignment? #

Returns `true` if this enum value contains `Alignment`

def alloc_size? #

Returns `true` if this enum value contains `AllocSize`

def always_inline? #

Returns `true` if this enum value contains `AlwaysInline`

def arg_mem_only? #

Returns `true` if this enum value contains `ArgMemOnly`

def builtin? #

Returns `true` if this enum value contains `Builtin`

def by_val? #

Returns `true` if this enum value contains `ByVal`

def captures? #

Returns `true` if this enum value contains `Captures`

def cold? #

Returns `true` if this enum value contains `Cold`

def convergent? #

Returns `true` if this enum value contains `Convergent`

def dereferenceable? #

Returns `true` if this enum value contains `Dereferenceable`

def dereferenceable_or_null? #

Returns `true` if this enum value contains `DereferenceableOrNull`

def each_kind(& : UInt32 -> ) #
def imm_arg? #

Returns `true` if this enum value contains `ImmArg`

def in_alloca? #

Returns `true` if this enum value contains `InAlloca`

def in_reg? #

Returns `true` if this enum value contains `InReg`

def inaccessible_mem_only? #

Returns `true` if this enum value contains `InaccessibleMemOnly`

def inaccessible_mem_or_arg_mem_only? #

Returns `true` if this enum value contains `InaccessibleMemOrArgMemOnly`

def inline_hint? #

Returns `true` if this enum value contains `InlineHint`

def jump_table? #

Returns `true` if this enum value contains `JumpTable`

def min_size? #

Returns `true` if this enum value contains `MinSize`

def naked? #

Returns `true` if this enum value contains `Naked`

def nest? #

Returns `true` if this enum value contains `Nest`

def no_alias? #

Returns `true` if this enum value contains `NoAlias`

def no_builtin? #

Returns `true` if this enum value contains `NoBuiltin`

def no_capture? #

Returns `true` if this enum value contains `NoCapture`

def no_duplicate? #

Returns `true` if this enum value contains `NoDuplicate`

def no_free? #

Returns `true` if this enum value contains `NoFree`

def no_implicit_float? #

Returns `true` if this enum value contains `NoImplicitFloat`

def no_inline? #

Returns `true` if this enum value contains `NoInline`

def no_recurse? #

Returns `true` if this enum value contains `NoRecurse`

def no_red_zone? #

Returns `true` if this enum value contains `NoRedZone`

def no_return? #

Returns `true` if this enum value contains `NoReturn`

def no_sync? #

Returns `true` if this enum value contains `NoSync`

def no_unwind? #

Returns `true` if this enum value contains `NoUnwind`

def non_lazy_bind? #

Returns `true` if this enum value contains `NonLazyBind`

def non_null? #

Returns `true` if this enum value contains `NonNull`

def none? #
def optimize_for_size? #

Returns `true` if this enum value contains `OptimizeForSize`

def optimize_none? #

Returns `true` if this enum value contains `OptimizeNone`

def read_none? #

Returns `true` if this enum value contains `ReadNone`

def read_only? #

Returns `true` if this enum value contains `ReadOnly`

def returned? #

Returns `true` if this enum value contains `Returned`

def returns_twice? #

Returns `true` if this enum value contains `ReturnsTwice`

def s_ext? #

Returns `true` if this enum value contains `SExt`

def safe_stack? #

Returns `true` if this enum value contains `SafeStack`

def sanitize_address? #

Returns `true` if this enum value contains `SanitizeAddress`

def sanitize_memory? #

Returns `true` if this enum value contains `SanitizeMemory`

def sanitize_thread? #

Returns `true` if this enum value contains `SanitizeThread`

def stack_alignment? #

Returns `true` if this enum value contains `StackAlignment`

def stack_protect? #

Returns `true` if this enum value contains `StackProtect`

def stack_protect_req? #

Returns `true` if this enum value contains `StackProtectReq`

def stack_protect_strong? #

Returns `true` if this enum value contains `StackProtectStrong`

def struct_ret? #

Returns `true` if this enum value contains `StructRet`

def swift_error? #

Returns `true` if this enum value contains `SwiftError`

def swift_self? #

Returns `true` if this enum value contains `SwiftSelf`

def uw_table? #

Returns `true` if this enum value contains `UWTable`

def will_return? #

Returns `true` if this enum value contains `WillReturn`

def write_only? #

Returns `true` if this enum value contains `WriteOnly`

def z_ext? #

Returns `true` if this enum value contains `ZExt`